/*      
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
          programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.
    
        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
    
*/

#include "alphCRYPT.h"

int
bifid(char *org, char *key)
{
  int itra=0, itrb=0, itrc=0; 
  int sema=0, semb=0;
  char abc='a';
  char *ckey;
  int *hlpr[2], hlprb[1];
  char *dst;
  int test[30];
  
  struct xy
  {
    int x;
    int y;
  }*loc;
  
  static char pb[5][5] = { { 'b', 'g', 'w', 'k', 'z' }, 
                    { 'q', 'p', 'n', 'd', 's' },
                    { 'i', 'o', 'a', 'x', 'e' },
                    { 'f', 'c', 'l', 'u', 'm' },
                    { 't', 'h', 'y', 'v', 'r' }
                  };
  
  dst=(char *) calloc(sizeof(char), strlen(org));
  loc=(struct xy *) malloc(1*sizeof(struct xy));
  ckey=(char *) calloc(sizeof(char), strlen(key));
  
  for (loc->x = 0; loc->x < 5; loc->x++)
    for (loc->y = 0; loc->y <5; loc->y++)
    pb[loc->x][loc->y] = 0;
  
  for (loc->x = 0, itra = 0; loc->x <= strlen (key); loc->x++)
    {
      if (isupper (key[loc->x]))
        key[loc->x] = tolower (key[loc->x]);
      if (!strchr (ckey, key[loc->x]))
        ckey[itra++] = key[loc->x];
    }
  
  for (loc->y = 0, itra = 0; loc->y < 5 && itra < strlen (ckey); loc->y++)
    for (loc->x = 0; loc->x < 5 && itra < strlen (ckey); loc->x++)
      pb[loc->y][loc->x] = ckey[itra++];
  
  for (sema = loc->y - 1; abc <= 'z' && loc->y < 6; abc++)
    {
      if (loc->x > 4)
        {
          loc->x = 0;
          loc->y++;
        }
      for (itra = 0; itra <= sema; itra++)
        if (strchr (pb[itra], abc))
          break;
      if (itra > sema)
        pb[loc->y - 1][loc->x++] = abc;
    }

  hlpr[0]=(int *) calloc(sizeof(int), strlen(org));
  hlpr[1]=(int *) calloc(sizeof(int), strlen(org));
  
  for(itra=0, itrb=0, itrc=0, sema=1; itra<2*strlen(org); itra++)
    {
      if(sema && itra==strlen(org))
        {
          itra=0;
          sema--;
        }
       if(isalpha(org[itra]))
         {
           for(loc->y=0; loc->y<5; loc->y++)
             for(loc->x=0; loc->x<5; loc->x++)
               if(tolower(org[itra])==pb[loc->y][loc->x])
                {
                  if(sema)
                    {
                      hlpr[0][itrb++]=loc->x;
                    }
                  else
                    {
                      hlpr[1][itrc++]=loc->y;
                    }
                }
         }
    }

  if(!al_dec)
    {
      for(itra=0, sema=1, itrb=0; itra<2*strlen(org); itra++)
        {
          if (itra==strlen(org)-1)
            {
              sema--;
              itrb=0;
            }
          if (sema)
            hlprb[itra]=hlpr[0][itrb++];
          else
            hlprb[itra]=hlpr[1][itrb++];
        }

      for(itra=0, itrb=0; itra<2*strlen(org)-2; itra+=2, itrb++)
        dst[itrb]=pb [hlprb[itra+1]][hlprb[itra]];
    }
  else
    {
      for (itra=0, itrb=0; itra<strlen(org)-1; itra++)
        {
            hlprb[itrb++]=hlpr[0][itra];
        }
      for (itra=0; itra<strlen(org)-1; itra++)
        {
            hlprb[itrb++]=hlpr[1][itra];
        }
    }

  strncpy(org, dst, strlen (dst));
  free(dst);

  return 0;

}
  
